Geometry displays incorrectly
Status: Closed

Priority: High

Assignee: Even Rouault

Category: Symbology

Affected QGIS version:2.16.1 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 23347

Description

Hello.

QGIS 2.12, 2.16.

Some of geometry (Polygons) such as from shapefiles displayed incorrectly. I am talking about polygons with rings inside. This polygons

display as filled polygons without rings.

In most cases, if you do not check it in advance, you can miss the fact that inside of those rings there might be an object. Also you can

miss fact that inside of polygon there might not be some area. If I use "Geometry checker" or "Topology checker" I can see that some

geometries are incorrect.  But for large projects doing this on a regular basis is extremely  unconfortable.

In other GIS when I add shapefile with incorrect geometries (from QGIS point of view) to project it displays all objects correctly or I can

see what needs to be.

In attachments demonstrate situation when inside polygon deleted ring and formed other polygon.

Associated revisions

Revision 89326395 - 2016-10-06 08:45 PM - Even Rouault

QgsSymbol::renderFeature(): render larger parts of multipolygon first

When drawing an invalid multipolygon, that has a part inside another one,

there is a chance we draw first the smaller part and then the larger part,

making it invisible.

Change the drawing order to start with larger parts.

Fixes #15419

History

#1 - 2016-10-06 11:48 AM - Even Rouault

- Assignee set to Even Rouault

#2 - 2016-10-07 01:54 AM - Even Rouault

- Status changed from Open to Closed

Fixed in changeset commit:"893263952d190d9abc2f239fa513cb327df77bee".

#3 - 2016-10-07 02:42 AM - Even Rouault

- Resolution set to fixed/implemented
- Target version set to Version 3.0

- Category set to Symbology

Backport to master_2 is not practical at all.

Files

qgis_fill_polygon.PNG 46.2 KB 2016-08-10 Evgeniy Z

qgis_polygon_checked.PNG 77 KB 2016-08-10 Evgeniy Z

ArcView_polygon_correctly.PNG 13 KB 2016-08-10 Evgeniy Z

incorrect_shape.zip 1.4 KB 2016-08-10 Evgeniy Z

2025-04-27 2/2


